/*
 * Copyright 2004-2010 Information & Software Engineering Group (188/1)
 *                     Institute of Software Technology and Interactive Systems
 *                     Vienna University of Technology, Austria
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.ifs.tuwien.ac.at/mir/index.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package at.tuwien.ifs.feature.extraction.audio.distance;

import at.tuwien.ifs.feature.extraction.audio.data.FeatureVectorData;

/**
 * Copyright Vienna University of Technology
 * 
 * @author Rudolf Mayer, changed by Thomas Lidy
 * @version $Id: VectorDistance.java 173 2010-06-17 16:28:05Z mayer $
 */
public class VectorDistance implements Comparable<VectorDistance> {

    private double distance;

    private FeatureVectorData featureVector;

    public VectorDistance(double distance, FeatureVectorData input) {
        super();
        this.distance = distance;
        this.featureVector = input;
    }

    public int compareTo(VectorDistance other) {
        return Double.compare(distance, other.distance);
        // return new Double(distance).compareTo(new Double(other.distance));
    }

    public double getDistance() {
        return distance;
    }

    public FeatureVectorData getFeatureVector() {
        return featureVector;
    }

}
