/*
 * Copyright 2004-2010 Information & Software Engineering Group (188/1)
 *                     Institute of Software Technology and Interactive Systems
 *                     Vienna University of Technology, Austria
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.ifs.tuwien.ac.at/mir/index.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package at.tuwien.ifs.feature.extraction.audio.input;

import java.util.LinkedList;
import java.util.List;

import at.tuwien.ifs.feature.extraction.audio.data.FeatureVectorData;

/**
 * Copyright Vienna University of Technology
 * 
 * @author Thomas Lidy
 * @version $Id: AbstractFileListReader.java 173 2010-06-17 16:28:05Z mayer $
 */
public abstract class AbstractFileListReader {

    // this list has to be populated with FeatureVectorData
    protected List<FeatureVectorData> metaDataList = new LinkedList<FeatureVectorData>();

    public List<FeatureVectorData> getMetaDataList() {
        return metaDataList;
    }

    public FeatureVectorData[] getFeatureVectors() {
        return metaDataList.toArray(new FeatureVectorData[metaDataList.size()]);
    }
}
