/*
 * Copyright 2004-2010 Information & Software Engineering Group (188/1)
 *                     Institute of Software Technology and Interactive Systems
 *                     Vienna University of Technology, Austria
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.ifs.tuwien.ac.at/mir/index.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package at.tuwien.ifs.feature.extraction.audio.input;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import at.tuwien.ifs.feature.extraction.audio.data.FeatureVectorData;

/**
 * Copyright Vienna University of Technology
 * 
 * @author Thomas Lidy
 * @version $Id: SimpleFileListReader.java 155 2010-06-16 15:45:39Z frank $
 */
public class SimpleFileListReader extends AbstractFileListReader {

    public SimpleFileListReader(File file) throws IOException {
        readFile(file);
    }

    private void readFile(File file) throws IOException {
        BufferedReader br;
        try {
            br = new BufferedReader(new FileReader(file));
        } catch (FileNotFoundException e) {
            throw new IOException("Could not find filelist file: " + e.getMessage());
        }

        String line;
        FeatureVectorData featVecMetaData;

        while ((line = br.readLine()) != null) {
            // System.out.println(line);
            featVecMetaData = new FeatureVectorData();
            featVecMetaData.setFileLabel(line);
            metaDataList.add(featVecMetaData);
        }

        br.close();
    }

}
