/*
 * Copyright 2004-2010 Information & Software Engineering Group (188/1)
 *                     Institute of Software Technology and Interactive Systems
 *                     Vienna University of Technology, Austria
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.ifs.tuwien.ac.at/mir/index.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package at.tuwien.ifs.feature.extraction.audio.vis;

import javax.swing.BoxLayout;

import javax.swing.BorderFactory;
import javax.swing.WindowConstants;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JProgressBar;

/**
 * Copyright Vienna University of Technology
 * 
 * @author Thomas Lidy
 * @version $Id: ExtractorStatusPanel.java 172 2010-06-17 16:21:16Z mayer $
 */
public class ExtractorStatusPanel extends javax.swing.JPanel {

    private static final long serialVersionUID = 1L;

    private static final int BORDER = 20;

    private JLabel lblIntro;

    private JProgressBar totalFilesProgressBar;

    private JLabel lblDummy;

    private JLabel lblTotalHead;

    private JLabel lblTotalInfo;

    private JLabel lblRemainInfo;

    private JProgressBar singleFileProgressBar;

    private JLabel lblFile;

    private JLabel lblSegment;

    private JLabel lblPath;

    /**
     * Auto-generated main method to display this JPanel inside a new JFrame.
     */
    public static void main(String[] args) {
        JFrame frame = new JFrame();
        frame.getContentPane().add(new ExtractorStatusPanel());
        frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        frame.pack();
        frame.setVisible(true);
    }

    public ExtractorStatusPanel() {
        super();
        initGUI();
    }

    private void initGUI() {
        setBorder(BorderFactory.createEmptyBorder(BORDER, BORDER, BORDER, BORDER));

        BoxLayout boxLayout = new BoxLayout(this, javax.swing.BoxLayout.Y_AXIS);
        this.setLayout(boxLayout);

        lblIntro = new JLabel();
        this.add(lblIntro);

        lblPath = new JLabel();
        this.add(lblPath);

        lblFile = new JLabel();
        this.add(lblFile);

        lblSegment = new JLabel();
        this.add(lblSegment);

        singleFileProgressBar = new JProgressBar();
        this.add(singleFileProgressBar);

        lblDummy = new JLabel();
        this.add(lblDummy);

        lblTotalHead = new JLabel();
        this.add(lblTotalHead);

        totalFilesProgressBar = new JProgressBar();
        this.add(totalFilesProgressBar);

        lblTotalInfo = new JLabel();
        this.add(lblTotalInfo);

        lblRemainInfo = new JLabel();
        this.add(lblRemainInfo);

        reset();
    }

    public void reset() {
        lblIntro.setText("Extracting audio features from ...");
        lblPath.setText("Path");
        lblFile.setText("Filename");
        lblSegment.setText(" ");
        lblDummy.setText(" ");
        lblTotalHead.setText("Total progress:");
        lblTotalInfo.setText("");
        lblRemainInfo.setText("");
    }

    public void setSingleFileProgressMaximum(int n) {
        singleFileProgressBar.setMaximum(n);
    }

    public void setSingleFileProgress(int n) {
        singleFileProgressBar.setValue(n);
    }

    public JProgressBar getSingleFileProgressBar() {
        return singleFileProgressBar;
    }

    public void setPathname(String pathname) {
        lblPath.setText(pathname);
    }

    public void setCurrentFilename(String filename) {
        lblFile.setText(filename);
    }

    public void setTotalFilesProgressMaximum(int n) {
        totalFilesProgressBar.setMaximum(n);
    }

    public void setTotalFilesProgress(int n) {
        totalFilesProgressBar.setValue(n);
    }

    public void setTotalInfo(String info) {
        lblTotalInfo.setText(info);
    }

    public void setRemainInfo(String info) {
        lblRemainInfo.setText(info);
    }

}
